# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1
%define _deploy_c3p0 0

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}
%define repodir %{_javadir}/repository.jboss.com/org/hibernate/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
%define section free
%define reltag Final 
%define buildtag -redhat-1
%define hname hibernate-core
%define namedversion %{version}.%{reltag}
%define fullversion %{namedversion}%{buildtag}

Summary:        Relational persistence and query service
Name:           hibernate4
Version:        4.1.3
Release:        2.9.%{reltag}%{?dist}
Epoch:          0
License:        LGPL
URL:            http://www.hibernate.org/
Group:          Database
%if 0
git clone git://git.app.eng.bos.redhat.com/hibernate/hibernate-core.git && cd %{hname}
git checkout %{namedversion}
cd .. && tar --exclude=.git\* -cfz %{hname}-%{namedversion}-src.tar.gz %{hname}
%endif

Source0:        %{hname}-%{namedversion}-src.tar.gz
Source1:        libraries.gradle
Patch0:         prod.patch
Patch1:         JBPAPP-9142.patch

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:  jpackage-utils >= 0:1.7.3
Requires:  java >= 1.6.0

BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  gradle 
BuildRequires:  ant 
BuildRequires:  ant-antlr 
BuildRequires:  antlr-eap6 
BuildRequires:  jboss-logging 
BuildRequires:  jboss-logging-tools  
BuildRequires:  hibernate3-commons-annotations
BuildRequires:  jakarta-commons-collections 
BuildRequires:  jboss-transaction-api_1.1_spec 
BuildRequires:  jandex
BuildRequires:  hibernate-jpa-2.0-api
BuildRequires:  javassist-eap6 
BuildRequires:  dom4j
BuildRequires:  c3p0
BuildRequires:  hibernate-beanvalidation-api 
# BuildRequires:  hibernate4-validator 
BuildRequires:  jboss-jacc-api_1.4_spec
BuildRequires:  java-classmate
#BuildRequires:  jboss-marshalling 
BuildRequires:  jgroups
BuildRequires:  i18nlog
BuildRequires:  maven-wagon
############## for jaxb
BuildRequires:  glassfish-jaxb
BuildRequires:  glassfish-jaf
BuildRequires:  codemodel
BuildRequires:  jing
BuildRequires:  txw2
BuildRequires:  txwc2
BuildRequires:  relaxngcc
BuildRequires:  relaxngDatatype
BuildRequires:  istack-commons
BuildRequires:  rngom
BuildRequires:  args4j
BuildRequires:  xsom
BuildRequires:  dtd-parser
BuildRequires:  xml-commons-resolver
BuildRequires:  jaxb2-commons-basics
BuildRequires:  apache-commons-logging
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-lang
BuildRequires:  jboss-jaxb-api_2.2_spec
############## for jaxb end

BuildRequires:  rhq-pluginAnnotations
BuildRequires:  infinispan
BuildRequires:  infinispan-cachestore-jdbc
BuildRequires:  infinispan-cachestore-parent
BuildRequires:  infinispan-cachestore-remote
BuildRequires:  infinispan-client-hotrod
BuildRequires:  infinispan-parent
BuildRequires:  infinispan-core

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate is a powerful, ultra-high performance 
object/relational persistence and query service 
for Java. Hibernate lets you develop persistent 
objects following common Java idiom - including 
association, inheritance, polymorphism, composition 
and the Java collections framework. Extremely 
fine-grained, richly typed object models are 
possible. The Hibernate Query Language, designed 
as a "minimal" object-oriented extension to SQL, 
provides an elegant bridge between the object and 
relational worlds. Hibernate is now the most 
popular ORM solution for Java.

%if %{with_repolib}
%package     repolib
Summary:     Artifacts to be uploaded to a repository library
Group:       Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package core
Summary:        Hibernate Core
Group:          Development/Java

Requires:       antlr-eap6
Requires:       jboss-logging
Requires:       hibernate3-commons-annotations
Requires:       jboss-transaction-api_1.1_spec 
Requires:       hibernate-jpa-2.0-api
Requires:       javassist-eap6 
Requires:       dom4j

%description core
Hibernate Core module.

%package c3p0
Summary:        Hibernate C3p0
Group:          Development/Java
Requires:       %{name}-core
Requires:       c3p0

%description c3p0
Hibernate C3p0 module.

%package entitymanager
Summary:        Hibernate EntityManager
Group:          Development/Java
Requires:       %{name}-core

%description entitymanager
Hibernate EntityManager module.

%package envers
Summary:        Hibernate Envers
Group:          Development/Java
Requires:       %{name}-core
Requires:       %{name}-entitymanager

%description envers
Hibernate Envers module.

%package infinispan
Summary:        Hibernate Infinispan
Group:          Development/Java
Requires:       %{name}-core
Requires:       infinispan

%description infinispan
Hibernate Infinispan module.

%prep
%setup -q -n %{hname}
%patch0 -p1
%patch1 -p1
sed -i "s|'/usr/share/java/slf4j',|'/usr/share/java/slf4j','/usr/share/java/javassist-eap6','/usr/share/java/antlr-eap6',|g" build.gradle
sed -i "s|compile 'org.javassist:javassist:3.15.0-GA'|compile 'org.javassist:javassist:3.15.0-GA-redhat-1'|g" buildSrc/build.gradle
sed -i "s|jbossas-fordev'])|jbossas-fordev','/usr/share/java/javassist-eap6'])|g" buildSrc/build.gradle
# remove tests and unused modules
%{__rm} -rf hibernate-core/src/matrix
%{__rm} -rf hibernate-core/src/test
%{__rm} -rf hibernate-envers/src/matrix
%{__rm} -rf hibernate-entitymanager/src/matrix
%{__rm} -rf hibernate-entitymanager/src/test
%{__rm} -rf hibernate-infinispan/src/test
%{__rm} -rf hibernate-c3p0/src/test
%{__rm} -rf databases
%{__rm} -rf documentation
%{__rm} -rf hibernate-ehcache
%{__rm} -rf hibernate-proxool
%{__rm} -rf hibernate-testing
%{__rm} changelog.txt
%{__rm} -rf hibernate-envers/src/main/java/org/hibernate/tool/ant
%{__rm} -rf hibernate-envers/src/main/java/org/hibernate/envers/ant
%{__cp} %{SOURCE1} .
%build

export GRADLE_USER_HOME=`pwd`/.gradle
export GROOVY_HOME=%{_javadir}
export _OPTS="--stacktrace --debug -Djava.endorsed.dirs=$GRADLE_USER_HOME/endorsed"
export JAVA_OPTS="-Xms512M -Xmx1024M -XX:MaxPermSize=512M -Djava.awt.headless=true"
export LOCAL_REPO=`pwd`/local
mkdir -p $GRADLE_USER_HOME/endorsed
#cp /usr/share/java/jboss-jaxb-api_2.2_spec-1.0.4.Final-redhat-1.jar $GRADLE_USER_HOME/endorsed
%{__ln_s} `%{_bindir}/build-classpath jboss-jaxb-api_2.2_spec` $GRADLE_USER_HOME/endorsed/jaxb-api.jar
%{__rm} -rf ${LOCAL_REPO}
%{__mkdir_p} ${LOCAL_REPO}
sed -i "s|REPOSITORY_PLACE_HOLDER|`pwd`/maven2-brew|g" build.gradle
%{_bindir}/gradle ${_OPTS}  clean install uploadArchives 
%{_bindir}/gradle ${_OPTS}  :release:buildReleaseBundles

%install
%{__rm} -rf $RPM_BUILD_ROOT
# jars
%{__mkdir_p} $RPM_BUILD_ROOT%{_javadir}/%{name}
%{__cp} -p */target/libs/hibernate-*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in hibernate-*.jar; do mv ${jar} `echo $jar | sed "s|hibernate|%{name}|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{fullversion}*.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|hibernate|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{fullversion}*.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{fullversion}||g"`; done)
# etc
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/%{name}/etc
%{__cp} -p etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}/etc

# pom
%add_to_maven_depmap org.hibernate hibernate-core %{fullversion} JPP %{name}-core
%add_to_maven_depmap org.hibernate hibernate-infinispan %{fullversion} JPP %{name}-infinispan
%add_to_maven_depmap org.hibernate hibernate-envers %{fullversion} JPP %{name}-envers
%add_to_maven_depmap org.hibernate hibernate-entitymanager %{fullversion} JPP %{name}-entitymanager
%add_to_maven_depmap org.hibernate hibernate-c3p0 %{fullversion} JPP %{name}-c3p0

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 hibernate-core/target/poms/pom-default.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-core.pom
install -m 644 hibernate-envers/target/poms/pom-default.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-envers.pom
install -m 644 hibernate-entitymanager/target/poms/pom-default.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-entitymanager.pom
install -m 644 hibernate-infinispan/target/poms/pom-default.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-infinispan.pom
install -m 644 hibernate-c3p0/target/poms/pom-default.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-c3p0.pom

# javadoc
%{__mkdir_p} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%{__cp} -pr release/target/documentation/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
    %{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
    %{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
    install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
    install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
    (cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in %{name}-*-%{fullversion}*.jar; do cp -p ${jar} $RPM_BUILD_ROOT%{repodirlib}/`echo $jar| sed "s|-%{fullversion}||g" | sed "s|%{name}|hibernate|g"`; done)
    (cd $RPM_BUILD_ROOT%{_datadir}/maven2/poms && for pom in JPP-%{name}*.pom; do cp -p ${pom} $RPM_BUILD_ROOT%{repodirlib}/`echo $pom| sed "s|JPP-%{name}|hibernate|g"`; done)

    # we do not want hibernate-c3p0 be added into repo lib rpm ( nor deploy into mead repo )
    # since this is only for EWS, not EAP.
    %{__rm} -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/hibernate/hibernate-c3p0
    %{__rm} -rf $RPM_BUILD_ROOT%{repodirlib}/hibernate-c3p0*
%endif

# dist
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-fordev
%{__cp} release/target/hibernate-release*.zip $RPM_BUILD_ROOT%{_javadir}/%{name}-fordev/hibernate-dist.zip
cd $RPM_BUILD_ROOT%{_javadir}/%{name}-fordev/
unzip hibernate-dist.zip
rm -rf hibernate-release-4.1.3.Final-redhat-1/lib/optional/infinispan
rm hibernate-dist.zip
zip -r hibernate-dist.zip hibernate-release-4.1.3.Final-redhat-1
rm -rf hibernate-release-4.1.3.Final-redhat-1
cd -
# License
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
%{__cp} -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}/lgpl.txt
%{_datadir}/%{name}
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%files core
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-core*.jar
%{_javadir}*/%{name}/hibernate-core*.jar
#poms
%{_datadir}/maven2/poms/JPP-%{name}-core*.pom

%files c3p0
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-c3p0*.jar
%{_javadir}*/%{name}/hibernate-c3p0*.jar
#poms
%{_datadir}/maven2/poms/JPP-%{name}-c3p0*.pom

%files entitymanager
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-entitymanager*.jar
%{_javadir}*/%{name}/hibernate-entitymanager*.jar
#poms
%{_datadir}/maven2/poms/JPP-%{name}-entitymanager*.pom

%files envers
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-envers*.jar
%{_javadir}*/%{name}/hibernate-envers*.jar
#poms
%{_datadir}/maven2/poms/JPP-%{name}-envers*.pom

%files infinispan
%defattr(0644,root,root,0755)
%{_mavendepmapfragdir}/%{name}
#jars
%{_javadir}*/%{name}/%{name}-infinispan*.jar
%{_javadir}*/%{name}/hibernate-infinispan*.jar
#poms
%{_datadir}/maven2/poms/JPP-%{name}-infinispan*.pom



%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%files zip
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-fordev/*.zip

%changelog
* Tue Jun 26 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.9.Final
- Change to R antlr-eap6, javassist-eap6
- Remove hibernate-infinispan from zip 

* Thu May 25 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.8.Final
- Add patch to fix JBPAPP-9142

* Thu May 24 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.7.Final
- Upgrade to jboss-logging 3.1.1.Final in libraries.gradle

* Mon May 07 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.6.Final
- Upgrade to 4.1.3.Final-redhat-1

* Mon Apr 23 2012 Strong Liu <stliu@redhat.com> 4.1.3-2.5.ER1
- Upgrade to 4.1.3.ER1-redhat-1

* Thu Apr 05 2012 Strong Liu <stliu@redhat.com> 4.1.2-2.4.Final
- Upgrade to 4.1.2.Final-redhat-1

* Tue Mar 27 2012 Strong Liu <stliu@redhat.com> 4.1.1-2.3.Final
- Upgrade to 4.1.1.Final-redhat-1

* Tue Mar 20 2012 Strong Liu <stliu@redhat.com> 4.0.3-2.2.Final
- Upgrade to 4.0.3.Final-redhat-1

* Mon Mar 07 2012 Strong Liu <stliu@redhat.com> 4.0.2-2.1.Final
- Apply patch to include HHH-6100 and HHH-5927

* Mon Mar 05 2012 Strong Liu <stliu@redhat.com> 4.0.2-2.0.Final
- Upgrade to 4.0.2

* Wed Feb 08 2012 Strong Liu <stliu@redhat.com> 4.0.1-1.9.Final
- Upgrade to 4.0.1

* Tue Dec 27 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.8.Final
- Make com.fasterxml:classmate dependency provided scope

* Mon Dec 26 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.7.Final
- Upgrade javassist dependey to 3.15.0-GA

* Mon Dec 19 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.6.Final
- Upgrade to 4.0.0.Final

* Fri Dec 16 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.5.CP07
- Rebuild to change javassist groupId to org.javassist

* Wed Dec 07 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.4.CP07
- Upgrade to 4.0.0.CP07

* Mon Nov 21 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.3.CP06
- Split hibernate artifacts into sub-package
- Note : hibernate-c3p0 is not included in the -repolib rpm, so this is not deploied into the MEAD repo
- but hibernate-c3p0 is in the -zip rpm

* Thu Nov 17 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.2.CP06
- Upgrade to 4.0.0.CP06
- Add hibernate-c3p0 package

* Sun Oct 30 2011 Strong Liu <stliu@redhat.com> 4.0.0-1.1.CP05
- Upgrade to use jboss logging tool 1.0.0.CR1

* Sat May 07 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.8.GA_CP04
- Rebuild



